package ac.ed.lurg.country;

import ac.ed.lurg.ModelConfig;

public class GlobalPrice {
	double importPrice;
	double exportPrice;
	double importAmount;
	double exportAmount;

	public GlobalPrice(double importPrice, double exportPrice, double importAmount, double exportAmount) {
		this.importPrice = importPrice;
		this.exportPrice = exportPrice;
		this.importAmount = importAmount;
		this.exportAmount = exportAmount;
	}
	
//	public static GlobalPrice createInitial(double exportPrice) {
//		return new GlobalPrice(exportPrice, exportPrice * (1-ModelConfig.TRANSPORT_LOSSES) / ModelConfig.TRADE_BARRIER_FACTOR, Double.NaN, Double.NaN);
//	}
//removed trade barriers adjustment as this is now done per country	
	public static GlobalPrice createInitial(double exportPrice) {
		return new GlobalPrice(exportPrice, exportPrice * (1-ModelConfig.TRANSPORT_LOSSES), Double.NaN, Double.NaN);
	}

	public double getImportPrice() {
		return importPrice;
	}
	
	public double getExportPrice() {
		return exportPrice;
	}
	
	public double getImportAmount() {
		return importAmount;
	}
	
	public double getExportAmount() {
		return exportAmount;
	}

	public GlobalPrice createWithUpdatedMarketPrices(double imports, double exports) {
		if (imports > 0 || exports > 0) {
			double ratio;

			if (imports > exports)
				ratio = (imports-exports)/imports;
			else
				ratio = (imports-exports)/exports;

			double adjustment = Math.exp(ratio * ModelConfig.MARKET_LAMBA);
			return new GlobalPrice(importPrice * adjustment, exportPrice * adjustment, imports, exports);
		}
		else {
			return this;
		}
	}

	@Override
	public String toString() {
		return String.format("import=%.3f export=%.3f", importPrice, exportPrice);
	}
}
