package ac.ed.lurg.country.gams;

import java.util.Map;

import ac.ed.lurg.landuse.CropUsageData;
import ac.ed.lurg.landuse.LandUseItem;
import ac.ed.lurg.types.CropType;

public class GamsLocationOutput {
	int status;
	
	Map<Integer, LandUseItem> landUses;  // data mapped from id (not raster)
	private Map<CropType, CropUsageData> cropUsageData;
	Map<CropType, Double> cropAdjustments;
	
	public GamsLocationOutput(int status, 
			Map<Integer, LandUseItem> landUses, 
			Map<CropType, CropUsageData> cropUsageData,
			Map<CropType, Double> cropAdjustments) {
		super();
		this.status = status;
		this.landUses = landUses;
		this.cropUsageData = cropUsageData;
		this.cropAdjustments = cropAdjustments;
	}
	
	public int getStatus() {
		return status;
	}
	public Map<Integer, LandUseItem> getLandUses() {
		return landUses;
	}

	public Map<CropType, CropUsageData> getCommoditiesData() {
		return cropUsageData;
	}
	
	public Map<CropType, Double> getCropAdjustments() {
		return cropAdjustments;
	}

}
