package ac.ed.lurg.country.gams;

import ac.ed.lurg.Timestep;
import ac.ed.lurg.landuse.LandUseItem;
import ac.ed.lurg.landuse.IrrigationItem;
import ac.ed.lurg.yield.YieldRaster;
import ac.sac.raster.RasterSet;

public class GamsRasterInput {
	
	private Timestep timestep;
	private YieldRaster yields;
	private RasterSet<LandUseItem> previousLandsUses;
	private RasterSet<IrrigationItem> irrigationCost;
	private GamsCountryInput countryInput;

	public GamsRasterInput(Timestep timestep, YieldRaster yields, RasterSet<LandUseItem> previousLandsUses, 
			RasterSet<IrrigationItem> irrigationCost, GamsCountryInput countryInput) {
		super();
		this.timestep = timestep;
		this.yields = yields;
		this.previousLandsUses = previousLandsUses;
		this.irrigationCost = irrigationCost;
		this.countryInput = countryInput;
	}

	public YieldRaster getYields() {
		return yields;
	}

	public RasterSet<LandUseItem> getPreviousLandUses() {
		return previousLandsUses;
	}
	
	public RasterSet<IrrigationItem> getIrrigationData() {
		return irrigationCost;
	}
	
	public GamsCountryInput getCountryInput() {
		return countryInput;
	}
	
	public Timestep getTimestep() {
		return timestep;
	}
}
