package ac.ed.lurg.country.gams;

import java.util.Map;

import ac.ed.lurg.landuse.CropUsageData;
import ac.ed.lurg.landuse.LandUseItem;
import ac.ed.lurg.types.CropType;
import ac.sac.raster.IntegerRasterItem;
import ac.sac.raster.RasterSet;

public class GamsRasterOutput {
	
	private int status;
	
	private RasterSet<LandUseItem> landUses;
	private RasterSet<IntegerRasterItem> locationIdRaster;
	
	private Map<CropType, CropUsageData> cropUsageData;
	private Map<CropType, Double> cropAdjustments;

	public GamsRasterOutput(RasterSet<LandUseItem> landUses, Map<CropType, CropUsageData> cropUsageData) {
		super();
		this.landUses = landUses;
        this.cropUsageData = cropUsageData;
	}

	public GamsRasterOutput(int status, RasterSet<LandUseItem> intensityRaster, Map<CropType, CropUsageData> cropUsageData, 
			Map<CropType, Double> cropAdjustments, RasterSet<IntegerRasterItem> locationIdRaster) {
		this(intensityRaster, cropUsageData);
		this.status = status;
		this.cropAdjustments = cropAdjustments;
		this.locationIdRaster = locationIdRaster;
	}
	
	public int getStatus() {
		return status;
	}
	
	public RasterSet<LandUseItem> getLandUses() {
		return landUses;
	}
		
	public RasterSet<IntegerRasterItem> getLocationIdRaster() {
		return locationIdRaster;
	}

	public Map<CropType, CropUsageData> getCropUsageData() {
		return cropUsageData;
	}

	public Map<CropType, Double> getCropAdjustments() {
		return cropAdjustments;
	}
}
