package ac.ed.lurg.landuse;

import java.util.Map;

import ac.ed.lurg.types.LandCoverType;
import ac.sac.raster.AbstractTabularRasterReader;
import ac.sac.raster.RasterKey;
import ac.sac.raster.RasterSet;

public class LandCoverReader extends AbstractTabularRasterReader<LandCoverItem> {	

	private static final int MIN_COLS = 6;

	
	public LandCoverReader(RasterSet<LandCoverItem> landCover) {
		super(" +", MIN_COLS, landCover);
	}
		
	@Override
	protected void setData(RasterKey key, LandCoverItem lcData, Map<String, Double> rowValues) {
	
		lcData.setTotalArea(dataset.getAreaMha(key));		
		lcData.setLandCoverFract(LandCoverType.CROPLAND, getValueForCol(rowValues, "cropland"));
		lcData.setLandCoverFract(LandCoverType.PASTURE, getValueForCol(rowValues, "pasture"));
		lcData.setLandCoverFract(LandCoverType.OTHER_NATURAL, getValueForCol(rowValues, "natural"));
		lcData.setLandCoverFract(LandCoverType.BARREN, getValueForCol(rowValues, "barren"));
		
	}
}
