package ac.ed.lurg.types;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

public enum CommodityType {

	CEREALS("Cereals - Excluding Beer + (Total)", "cereals"),
	OILCROPS("Oilcrops + (Total)", "oilcrops"),
	PULSES("Pulses + (Total)", "pulses"),
	SOYBEAN("Soyabeans", "soybean"),
	STARCHY_ROOTS("Starchy Roots + (Total)", "starchyRoots"),
	MEAT("meatmilkeggs", "meat");

	private String faoName;
	private String gamsName;
	
	CommodityType (String faoName, String gamsName) {
		this.faoName = faoName;
		this.gamsName = gamsName;
	}
	
	private static final Map<String, CommodityType> faoNameCache = new HashMap<String, CommodityType>();
    static {
        for (CommodityType c : values()) {
        	faoNameCache.put(c.getFaoName(), c);
       }
    }

	public static CommodityType getForFaoName(String faoName) {
		CommodityType commodity = faoNameCache.get(faoName);

		if (commodity == null) 
			throw new RuntimeException("Can't find CommodityType for faoName: " + faoName);
		
		return commodity;
	}
	
	public static Collection<CommodityType> getAllItems() {
		return faoNameCache.values();
	}

	public String getFaoName() {
		return faoName;
	}
	
	public String getGamsName() {
		return gamsName;
	}
}
