package ac.ed.lurg.yield;

import ac.ed.lurg.types.CropType;
import ac.ed.lurg.types.YieldType;
import ac.ed.lurg.utils.LogWriter;
import ac.sac.raster.AbstractRasterReader;
import ac.sac.raster.RasterHeaderDetails;

public class YieldResponseMapReader extends AbstractRasterReader<YieldResponsesItem> {	

	private YieldType yieldType;
	private CropType cropType;
	
	public YieldResponseMapReader (YieldRaster dataset, YieldType yieldType, CropType cropType) {
		super(dataset);
		this.yieldType = yieldType;
		this.cropType = cropType;
	}

	protected void createDataSet(RasterHeaderDetails header) {
		if (DEBUG) LogWriter.println("Creating RasterDataset col:"+header.getNcolumns() + ", rows:" + header.getNrows());

		if (dataset == null) {
			dataset = new YieldRaster(header);
		}
	}

	@Override
	public void setData(YieldResponsesItem item, String token) {
		double d = Double.parseDouble(token);
		item.setYield(yieldType, cropType, d);
	}
}