package ac.ed.lurg.yield;

import java.util.HashMap;
import java.util.Map;

import ac.ed.lurg.types.CropType;
import ac.ed.lurg.types.YieldType;
import ac.sac.raster.RasterItem;

public class YieldResponsesItem implements RasterItem {
	Map<CropType, YieldResponse> yieldResponses = new HashMap<CropType, YieldResponse>();
	private boolean isSpringWheat;  // used to indicate is wheat is spring or winter wheat
	
	public void setYield(YieldType type, CropType crop, double yield) {
		getYieldResponseForCrop(crop).setYield(type, yield);
	}

	YieldResponse getYieldResponseForCrop(CropType crop) {
		YieldResponse yresp = yieldResponses.get(crop);
		if (yresp == null) {
			yresp = new YieldResponse();
			yieldResponses.put(crop, yresp);
		}
		return yresp;
	}
	
	public double getYield(YieldType yieldType, CropType crop) {
		YieldResponse yr = getYieldResponseForCrop(crop);
		double d = yr.getYield(yieldType);
		return d;
	}	

	public double getYieldNone(CropType crop) {
		return getYield(YieldType.NO_FERT_NO_IRRIG, crop);
	}	
	
	public double getYieldMidFertOnly(CropType crop) {
		return getYield(YieldType.FERT_MID_NO_IRRIG, crop);
	}

	public double getYieldFertOnly(CropType crop) {
		return getYield(YieldType.FERT_MAX_NO_IRRIG, crop);
	}
	
	public double getYieldIrrigOnly(CropType crop) {
		return getYield(YieldType.NO_FERT_IRRIG_MAX, crop);
	}
	
	public double getYieldMax(CropType crop) {
		return getYield(YieldType.FERT_MAX_IRRIG_MAX, crop);
	}
	
	public double getFertParam(CropType crop) {
		return getYieldResponseForCrop(crop).getFertParam();
	}
	
	public double getIrrigParam(CropType crop) {
		return getYieldResponseForCrop(crop).getIrrigParam();
	}

	public void setIsSpringWheat(boolean isSpringWheat) {
		this.isSpringWheat = isSpringWheat;
	}
	
	public boolean isSpringWheat() {
		return isSpringWheat;
	}
}